package me.mctp.listener;

import me.mctp.Main;
import me.mctp.managers.PinManager;
import net.raidstone.wgevents.events.RegionsEnteredEvent;
import net.raidstone.wgevents.events.RegionsLeftEvent;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.json.simple.JSONObject;

import java.util.Collections;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;

public class WGListener implements Listener {
    @EventHandler
    public void onRegionEnter(RegionsEnteredEvent e) {
        Set<String> list = Main.getPlugin().getConfig().getConfigurationSection("Regions").getKeys(false);

        if (!Collections.disjoint(list, e.getRegionsNames())) {
            //One element is the same -> In a region

            Optional<String> name = e.getRegionsNames().stream().filter(list::contains).findFirst();
            if (!name.isPresent()) return;
            String regionURL = Main.getPlugin().getConfig().getString("Regions." + name.get());

            JSONObject data = new JSONObject();

            if (!PinManager.hasPin(Objects.requireNonNull(e.getPlayer()).getUniqueId())) return;

            data.put("task", "MUSIC");
            data.put("path", regionURL);
            data.put("uuid", e.getPlayer().getUniqueId().toString().replace("-", ""));
            Main.getClient().sendData(data);
        }
    }

    @EventHandler
    public void onRegionExit(RegionsLeftEvent e) {
        Set<String> list = Main.getPlugin().getConfig().getConfigurationSection("Regions").getKeys(false);

        if (!Collections.disjoint(list, e.getRegionsNames())) {
            //One element is the same -> In a region
            JSONObject data = new JSONObject();

            if (!PinManager.hasPin(Objects.requireNonNull(e.getPlayer()).getUniqueId())) return;

            data.put("task", "MUSIC");
            data.put("path", "");
            data.put("uuid", e.getPlayer().getUniqueId().toString().replace("-", ""));
            Main.getClient().sendData(data);
        }
    }
}
